﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace TradePumpNet
{
    /// <summary>
    /// This is freeware for any use. Use at your own risk.
    /// Written by: Rob Hull software services rob@hullhaven.com
    /// </summary>
    public class Datapump
    {
        //AsynchronousSocketListener _listener = null;
        List<Chart> listenForSymbols = new List<Chart>();
        readonly object _lock = new object();

        ~Datapump()
        {
            //if (_listener != null)
            //{
            //    _listener.StopListening();
            //    _listener = null;
            //}
        }

        // call this method from your implementation, from another thread that you start with the instance of this class
        // AsynchronousSocketListener has a seperate tread that calls this method as ticks arrive.
        internal void OnTick(object sender, List<Quote> e)
        {
            lock (_lock)
            {
                foreach (Quote item in e)
                {
                    var symbols = listenForSymbols.Where(c => c.Symbol == item.Symbol);
                    if (symbols != null)
                    {
                        foreach (var chart in symbols)
                        {
                            int ret;
                            ret = UnmanagedExports.NSTSETVALUE(chart.Symbol, chart.Interval, 1, item.TimeStamp.ToOADate());
                            ret = UnmanagedExports.NSTSETVALUE(chart.Symbol, chart.Interval, 2, item.Bid);
                            ret = UnmanagedExports.NSTSETVALUE(chart.Symbol, chart.Interval, 3, item.Vol);
                            ret = UnmanagedExports.NSTCOMMITROW(chart.Symbol, chart.Interval);
                        }
                    }
                }
            }
        }

        public void Start()
        {
            Logger.Log("Start Pump");
        }

        public void GetBars(string ticker, double julianStartDate, int interval)
        {
            Logger.Log("GetBars(" + ticker + "," +  DateTime.FromOADate(julianStartDate).ToString("G") + "," + interval.ToString() + ")");
            //IList<Quote> bars = Get from your implementation
            //foreach (Quote item in bars)  //where item is a Quote object
            //{
            //    double date = item.BarTimeStamp.Value.ToOADate();
            //    if (firstRecord)
            //    {
            //        date = julianStartDate;
            //        firstRecord = false;
            //    }
            //    int ret;

            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 1, date);
            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 2, item.Open.Value);
            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 3, 0);
            //    ret = UnmanagedExports.NSTCOMMITROW(ticker, revInterval);

            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 1, date);
            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 2, item.High.Value);
            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 3, 0);
            //    ret = UnmanagedExports.NSTCOMMITROW(ticker, revInterval);

            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 1, date);
            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 2, item.Low.Value);
            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 3, 0);
            //    ret = UnmanagedExports.NSTCOMMITROW(ticker, revInterval);

            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 1, date);
            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 2, item.Close.Value);
            //    ret = UnmanagedExports.NSTSETVALUE(ticker, revInterval, 3, item.Volume.Value);
            //    ret = UnmanagedExports.NSTCOMMITROW(ticker, revInterval);

            //    count++;
            //    double ct = (double)count;
            //    double rw = (double)rowCount;
            //    double per = (ct / rw) * 100.0;

            //    int newPercent = (int)per;
            //    if (newPercent != percent)
            //    {
            //        percent = newPercent;
            //        UnmanagedExports.UpdatePercent(newPercent);
            //        System.Windows.Forms.Application.DoEvents();  // used to allow Neuro Shell to repaint the progress bar.
            //    }
            //}
        }

        public void AddSymbol(string ticker, int interval)
        {
            lock (_lock)
            {
                if (!listenForSymbols.Any(s => s.Symbol == ticker && s.Interval == interval))
                {
                    Chart chart = new Chart();
                    chart.Symbol = ticker;
                    chart.Interval = interval;
                    listenForSymbols.Add(chart);
                    Logger.Log("Added Symbol:" + ticker + " interval:" + interval.ToString());
                }
            }
        }

        public void RemoveSymbol(string ticker, int interval)
        {
            lock (_lock)
            {
                if (listenForSymbols.Any(s => s.Symbol.Equals(ticker, StringComparison.CurrentCultureIgnoreCase) && s.Interval == interval))
                {
                    listenForSymbols.RemoveAll(s => s.Symbol.Equals(ticker, StringComparison.CurrentCultureIgnoreCase) && s.Interval.Equals(interval));
                }
                Logger.Log("Remove Symbol:" + ticker + " interval:" + interval.ToString());
            }
        }
    }
}
